/* Stores serialized/gzipped proto responses.  Can key on anything, but default is url */
CREATE TABLE IF NOT EXISTS stored_message
(
    _id                         INTEGER     PRIMARY KEY,
    url                         TEXT        NOT NULL,
    class_id                    INTEGER     NOT NULL,      /* FK to message_classname */
    serialized_response         BLOB        NOT NULL,
    data_state                  TEXT        NOT NULL,      /* (L)ive, (D)eleted, (W)aiting */
    soft_expire                 INTEGER     NOT NULL,      /* Timestamp value */
    hard_expire                 INTEGER     NOT NULL       /* Timestamp value */
);

CREATE INDEX response_url_index ON stored_message(url);
CREATE INDEX response_expire_index ON stored_message(hard_expire);

/* Stores compressed image data.  Can key on anything, but default is url */
CREATE TABLE IF NOT EXISTS stored_bitmap
(
    _id                         INTEGER     PRIMARY KEY,
    url                         TEXT        NOT NULL,
    serialized_bitmap           BLOB        NOT NULL,
    data_state                  TEXT        NOT NULL,      /* (L)ive, (D)eleted, (W)aiting */
    soft_expire                 INTEGER     NOT NULL,      /* Timestamp value */
    hard_expire                 INTEGER     NOT NULL       /* Timestamp value */
);

CREATE INDEX bitmap_url_index ON stored_bitmap(url);
CREATE INDEX bitmap_expire_index ON stored_bitmap(hard_expire);

/* Normalized table for proto class identification */
CREATE TABLE IF NOT EXISTS message_classname
(
    _id                         INTEGER     PRIMARY KEY,
    classname                   TEXT        NOT NULL
);
